VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.2#0"; "comctl32.ocx"
Begin VB.Form frmFileFind 
   Caption         =   "clsFileFind Test"
   ClientHeight    =   5055
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6885
   LinkTopic       =   "Form1"
   ScaleHeight     =   5055
   ScaleWidth      =   6885
   StartUpPosition =   3  'Windows Default
   Begin ComctlLib.StatusBar Status 
      Align           =   2  'Align Bottom
      Height          =   255
      Left            =   0
      TabIndex        =   7
      Top             =   4800
      Width           =   6885
      _ExtentX        =   12144
      _ExtentY        =   450
      SimpleText      =   ""
      _Version        =   327682
      BeginProperty Panels {0713E89E-850A-101B-AFC0-4210102A8DA7} 
         NumPanels       =   3
         BeginProperty Panel1 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            Object.Width           =   1764
            MinWidth        =   1764
            Text            =   "clsFileFind"
            TextSave        =   "clsFileFind"
            Key             =   ""
            Object.Tag             =   ""
         EndProperty
         BeginProperty Panel2 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            Object.Width           =   2822
            MinWidth        =   2822
            Text            =   "www.classicvb.com"
            TextSave        =   "www.classicvb.com"
            Key             =   ""
            Object.Tag             =   ""
         EndProperty
         BeginProperty Panel3 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            Alignment       =   2
            AutoSize        =   1
            Object.Width           =   6985
            TextSave        =   ""
            Key             =   "Count"
            Object.Tag             =   ""
         EndProperty
      EndProperty
   End
   Begin VB.CheckBox chkRecursive 
      Caption         =   "Recursive"
      Height          =   255
      Left            =   1560
      TabIndex        =   6
      Top             =   840
      Width           =   1215
   End
   Begin VB.TextBox txtSearchSpec 
      Height          =   285
      Left            =   120
      TabIndex        =   4
      Text            =   "*.*"
      Top             =   840
      Width           =   1215
   End
   Begin VB.TextBox txtPath 
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Text            =   "C:\WINNT"
      Top             =   240
      Width           =   3135
   End
   Begin VB.CommandButton cmdPopulate 
      Caption         =   "Populate"
      Height          =   495
      Left            =   3480
      TabIndex        =   1
      Top             =   240
      Width           =   1215
   End
   Begin ComctlLib.ListView lvFiles 
      Height          =   3375
      Left            =   0
      TabIndex        =   0
      Top             =   1320
      Width           =   6855
      _ExtentX        =   12091
      _ExtentY        =   5953
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   0   'False
      HideSelection   =   0   'False
      _Version        =   327682
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   3
      BeginProperty ColumnHeader(1) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "FileName"
         Object.Width           =   5292
      EndProperty
      BeginProperty ColumnHeader(2) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   1
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Last Modified"
         Object.Width           =   2646
      EndProperty
      BeginProperty ColumnHeader(3) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         Alignment       =   1
         SubItemIndex    =   2
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Size"
         Object.Width           =   1764
      EndProperty
   End
   Begin VB.Label Label2 
      Caption         =   "Search Spec:"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   600
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Path:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   0
      Width           =   1215
   End
End
Attribute VB_Name = "frmFileFind"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*********'*********'*********'*********'*********'*********'*********'*********
'
' clsFileFind
' www.classicvb.com
'
' Written by David Crowell
'
' Released to the Public Domain
'
' An easier way to access the FindFirstFile and related API calls.  Uses a
' natural recordset-like method that most VB programmers already have adjusted
' to.
'
' No warranty of any kind is given, or to be implied on the quality
' or functionality of this software.
'
'*********'*********'*********'*********'*********'*********'*********'*********
Option Explicit

Private mlngCount As Long

Private Sub cmdPopulate_Click()

    Me.MousePointer = vbHourglass
    Status.Panels.Item("Count").Text = "Searching..."
    
    ' clear existing items
    lvFiles.ListItems.Clear
    
    mlngCount = 0
    
    ' populate the listview
    Call AddRecursive(txtPath.Text, txtSearchSpec.Text)
    
    Me.MousePointer = vbDefault
    Status.Panels.Item("Count").Text = mlngCount & " Files Found"
    
End Sub

Private Sub AddRecursive(ByVal Path As String, SearchSpec As String)
    
    Dim itm As ListItem
    
    With New clsFileFind
        
        ' find files only
        .FilterDotFolders = True
        .FilterAttributes = vbNormal
        .FilterAttributesMask = vbDirectory
        Call .Find(Path, SearchSpec)
        Do While Not .EOF
            Set itm = lvFiles.ListItems.Add(, , .FullPath)
            itm.SubItems(1) = .LastModified
            itm.SubItems(2) = .FileSize
            mlngCount = mlngCount + 1
            .MoveNext
        Loop
        .CloseFind
        
        ' now find folders if 'recursive' is checked
        If chkRecursive.Value = vbChecked Then
            .FilterDotFolders = True
            .FilterAttributes = vbDirectory
            .FilterAttributesMask = vbDirectory
            Call .Find(Path, "*.*")
            Do While Not .EOF
                Call AddRecursive(.FullPath, SearchSpec)
                .MoveNext
            Loop
        End If
        
    End With
            
End Sub

Private Sub Form_Resize()
    lvFiles.Move 0, 1320, Me.ScaleWidth, Me.ScaleHeight - (1340 + Status.Height)
End Sub
